--[[ This function is executed every time you press the 'execute' button ]]
function init()
    -- blue beacon mean it's the right information
    robot.leds.set_single_color(13, "red")
end

--moving ______________________________________________________________________________________________________________________________________________
function driveAsCar(forwardSpeed, angularSpeed)
    leftSpeed  = forwardSpeed - angularSpeed
    rightSpeed = forwardSpeed + angularSpeed
    robot.wheels.set_velocity(leftSpeed,rightSpeed)
end
-- ______________________________________________________________________________________________________________________________________________

--obstacle avoidance ______________________________________________________________________________________________________________________________________________
function avoiding(proxiLeft, proxiRight)
    for i = 1,5 do
        proxiLeft = proxiLeft + robot.proximity[i].value
    end
    for i = 19,24 do
        proxiRight = proxiRight + robot.proximity[i].value
    end

    if (proxiLeft ~= 0) and (proxiRight ~= 0) then
        --log("turn around")
        driveAsCar(0,40)
    elseif (proxiLeft ~= 0) and (proxiRight == 0) then
        --log("turn left")
        driveAsCar(30,-35)
    elseif (proxiLeft == 0) and (proxiRight ~= 0) then
        --log("turn right")
        driveAsCar(40,35)
    else
        --log("foward")
        ran = math.random(0,10)
        if (ran > 1) and (ran < 9) then
            driveAsCar(20,0)
        elseif ran <= 1 then
            robot.wheels.set_velocity(20,-20)
        elseif ran >= 9 then
            robot.wheels.set_velocity(-20,20)
        end
    end
end




--[[ This function is executed at each time step _______________________________________________________________________
It must contain the logic of your controller ]]
function step()
    avoiding(0,0)
end
-- ______________________________________________________________________________________________________________________________________________

--[[ This function is executed every time you press the 'reset'
button in the GUI. It is supposed to restore the state
of the controller to whatever it was right after init() was
called. The state of sensors and actuators is reset
automatically by ARGoS. ]]
function reset()
-- put your code here
end


--[[ This function is executed only once, when the robot is removed
from the simulation ]]
function destroy()
-- put your code here
end

